//application code
//to use, input a file to blur and a name to give it

import java.awt.*;

import java.awt.event.WindowEvent;
import java.awt.image.*;

import java.awt.event.*;

public class BlurSegmenter extends Frame {

	final static long serialVersionUID = 9283456823475L;

	private BufferedImage image;

	private short[][][] data;
	
	private final int BLUR_RADIUS = 2;
	private final double COMPOSITE = .7;
	private final int NUM_BLURS = 7;
	private final int THRESH_HOLD = 10;


	private final int BAR_SIZE = 25;

	public BlurSegmenter(String fileName, String fileName2) {
		System.out.println("Loading");
		data = ImageLoader.readShorts(fileName);
		System.out.println("Making pyramid");
		short[][][][] master = Shrinker.makePyramid(data);
		System.out.println("Blurring");
		int count = Shrinker.getCount(data);
		for (int i = count - 1; i > 0; i--) {
			master[i - 1] = Shrinker.merge(master[i - 1], master[i], COMPOSITE);
			BlurMaster.blur(master[i - 1], NUM_BLURS, BLUR_RADIUS, THRESH_HOLD);
		}
		System.out.println("Saving");
		ImageLoader.writeShorts(master[0], fileName2);
		System.out.println("Launching Viewer");
		image = ImageLoader.image;
		this.setTitle(fileName + " -> " + fileName2);
		this.setSize(image.getWidth(), image.getHeight());
		this.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				System.exit(0);
			}
		});
		this.setVisible(true);
		System.out.println("Done");
	}

	public void paint(Graphics graphics) {
		graphics.drawImage(image, 0, BAR_SIZE, null);
	}

	public static void main(String[] args) {
		if (args.length < 1 || args.length>2) {
			System.out.println("usage: BlurSegmenter (inputFile) (outputFile)");
			System.out.println("usage: BlurSegmenter (inputFile)");
		} else {
			new BlurSegmenter(args[0], args.length>1?args[1]:("blur_"+args[0]));
		}
	}
}