//code for loading images and returning them as arrays of shorts
//Tim Bahls


import javax.imageio.*;

import java.awt.image.*;
import java.io.*;

public class ImageLoader {
	
	static BufferedImage image;

	public static short[][][] readShorts(String fileName) {
		short[][][] data=null;
		image = ImageLoader.read(fileName);
		int hrz = image.getWidth(null);
		int vrt = image.getHeight(null);

		data = new short[hrz][vrt][3];
		for (int i = 0; i < hrz; i++) {
			for (int j = 0; j < vrt; j++) {
				int pixel = image.getRGB(i, j);

				data[i][j][0] = (short) ((pixel >> 16) & 0xff);
				data[i][j][1] = (short) ((pixel >> 8) & 0xff);
				data[i][j][2] = (short) ((pixel) & 0xff);

			}
		}
		return data;
	}

	public static void writeShorts(short[][][] data, String fileName) {
		image = new BufferedImage(data.length, data[0].length,
				5);
		for (int i = 0; i < data.length; i++) {
			for (int j = 0; j < data[0].length; j++) {

				image.setRGB(i, j, 256 * 256 * data[i][j][0] + 256
						* data[i][j][1] + data[i][j][2]);

			}
		}
		write(image, fileName);
	}

	public static BufferedImage read(String s){
		try {
			BufferedImage image = ImageIO.read(new File(s));
			return image;
		} catch (IOException e) {
			System.out.println("IO error when reading");
			e.printStackTrace();
			System.exit(1);
		}
		return null;
	}
	
	public static void write(BufferedImage image, String s){
		try {
			ImageIO.write(image, "png", new File(s));
		} catch (IOException e) {
			System.out.println("IO error when writing");
			e.printStackTrace();
			System.exit(1);
		}
	}

	
}