//shrinks an  image by a factor of two, creates a pyramid
//and merges the images back in
//

public class Shrinker {
	public static short[][][] shrink(short[][][] data) {
		int hrz = data.length;
		int vrt = data[0].length;
		int hrz2 = (hrz + 1) / 2;
		int vrt2 = (vrt + 1) / 2;
		short[][] kernal = { { 1, 2, 1 }, { 2, 4, 2 }, { 1, 2, 1 } };
		short[][][] ret = new short[hrz2][vrt2][3];
		for (int i = 0; i < hrz2; i++) {
			for (int j = 0; j < vrt2; j++) {
				int tot = 0;
				for (int x = 0; x < 3; x++) {
					if (x + i - 1 < 0 || x + i - 1 >= hrz2) {
						continue;
					}
					for (int y = 0; y < 3; y++) {
						if (y + j - 1 < 0 || y + j - 1 >= vrt2) {
							continue;
						}
						short k = kernal[x][y];
						tot += k;
						for (int c = 0; c < 3; c++) {

							ret[i][j][c] += (short) (data[2 * i + x - 1][2 * j
									+ y - 1][c] * k);
						}
					}
				}
				for (int c = 0; c < 3; c++) {
					ret[i][j][c] /= tot;
				}
			}
		}
		return ret;
	}
	
	public static short[][][][] makePyramid(short[][][] data) {

		int count = getCount(data);
		short[][][][] master = new short[count + 1][][][];
		master[0] = data;
		short[][][] tmp = data;

		for (int ind = 1; ind < master.length; ind++) {
			tmp = Shrinker.shrink(tmp);
			master[ind] = tmp;

		}
		return master;
	}
	
	public static  short[][][] merge(short[][][] big, short[][][] small, double d) {

		int hrz = big.length;
		int vrt = big[0].length;


		for (int i = 0; i < hrz; i++) {
			for (int j = 0; j < vrt; j++) {
				for (int c = 0; c < 3; c++) {
					boolean xEven = i % 2 == 0;
					boolean yEven = j % 2 == 0;
					short smallNum;
					int i2 = i / 2;
					int j2 = j / 2;
					if (xEven || i == hrz - 1) {
						if (yEven || j == vrt - 1) {
							smallNum = small[i2][j2][c];
						} else {
							smallNum = (short) ((small[i2][j2][c] + small[i2][j2 + 1][c]) / 2);
						}
					} else {
						if (yEven || j == vrt - 1) {
							smallNum = (short) ((small[i2][j2][c] + small[i2 + 1][j2][c]) / 2);
						} else {
							smallNum = (short) ((small[i2][j2][c]
									+ small[i2 + 1][j2][c]
									+ small[i2][j2 + 1][c] + small[i2 + 1][j2 + 1][c]) / 4);
						}
					}

					big[i][j][c] = ((short) (big[i][j][c] * (1 - d) + d
							* smallNum));

				}
			}
		}

		return big;
	}
	
	public static int getCount(short[][][] data) {
		int ii = Math.min(data.length, data[0].length);
		int count = 1;

		while (ii > 15) {
			count++;
			ii = (ii + 1) / 2;
		}
		return ii;
	}
}
